Geopackage layer rename in DB Manager does not update f_table_name values in the layer_styles
table or the Triggers
Status: Closed

Priority: Normal

Assignee: Martin Dobias

Category: DB Manager

Affected QGIS version:3.4.4 Regression?: No

Operating System: Windows 10 Easy fix?: No

Pull Request or Patch supplied: Resolution: fixed/implemented
Crashes QGIS or corrupls data: Copied to github as #: 29045
Description

We have a geopackage file with some layers and some styles for those layers, including default styles that display when we add the layers
to the map canvas.

We use DB Manager to rename one or more of the geopackage layers.

For the renamed layers, the text in the Triggers section of the DB Manager Info tab still refers to the old layer name, and we cannot edit
this (I do not know what consequences this may have).

In the layer_styles table for this geopackage, viewed in the Table tab of DB Manager, the values in the f_table_name still contain the old
layer names. Consequently, the correct default styles do not display when we add the layers to the Map Canvas, and in Layer Properties,
the Style > Load Style > from database (Geopackage) 'Database styles manager' dialog lists nothing under 'Styles related to the layer'.

We can find the appropriate style if we look for it in the list of 'Other styles on the database’, but this is a overly complicated procedure to
obtain the saved style, and it is not really something we can expect our novice-to-intermediate QGIS users to do every time.

Associated revisions

Revision 61d361d6 - 2019-02-12 07:37 PM - Alessandro Pasotti

GPKG: Rename styles when layers are renamed

Partially fixes #21227

TODO:

- DB manager

- Other providers

Revision 8639bcf8 - 2019-02-13 12:49 PM - Alessandro Pasotti

[db-manager] Use QgsDataltem implementation for GPKG layer rename

- Removes code duplication

- Uses a tested and robust implementation (from OGR)

- Takes care of renaming QGIS styles

- Updates the information view in the plugin
Fixes #21227

Revision 9eca4059 - 2019-04-09 09:41 AM - Martin Dobias
[db manager] Rename layer style entry when renaming gpkg tables (fixes #21227)
This has been already fixed in master and backported to 3.6 using browser data items.

However the fix can't be directly backported to QGIS 3.4 because in 3.4 geopackage
data item does not support renaming.

History

#1 - 2019-02-11 02:47 PM - Steve Lowman

| notice that there is a plugin called 'DB Style Manager', which is designed only for PostGIS connection, not for geopackages. Still, perhaps its code could

help with resolving this issue for geopackages, if the resolution is not easy.

Also, | wonder whether this bug also extends to PostGIS connections? | have not yet been able to test for this, as | do not yet make regular use of PostGIS.

#2 - 2019-02-12 08:42 AM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#3 - 2019-02-13 09:06 AM - Alessandro Pasotti

- Status changed from Open to In Progress
- Pull Request or Patch supplied changed from No to Yes

Ok for styles: I'm working on it on PR https:/github.com/qgis/QGIS/pull/9164

About triggers: what triggers exactly are not updated?
The current implementation relies on GDAL which does update all geopackage related triggers, if you have custom triggers then they will not be updated

and it's a won't fik (IMO).

#4 - 2019-02-13 10:53 AM - Steve Lowman
- File DB Manager Rename bug - Triggers.png added

Thanks Alessandro. For the Triggers, there are two of them in these layers, both seem to be about feature count - one for "insert" and the other for "delete".

| do not know what they really do.

| will attach an image to show these. | changed the layer name, but the previous layer name is still there for these insert and delete feature counts Triggers.

#5 - 2019-02-13 11:21 AM - Alessandro Pasotti

Oh, | see, it's an issue in the dialog which is not updated, the triggers are acually updated correctly in the DB but the dialog is not.

#6 - 2019-02-13 04:24 PM - Alessandro Pasotti
https://github.com/qgis/QGIS/pull/9164

- Status changed from In Progress to Closed

- % Done changed from 0 to 100

Applied in changeset commit:qgis|61d361d6746e2e6d668616b70597f1c81bb5486d.

#7 - 2019-02-25 04:02 PM - Steve Lowman
- Status changed from Closed to Reopened

Itis fixed in 3.6, but not fixed in the upgraded 3.4.5 LTR.

#8 - 2019-02-25 04:21 PM - Alessandro Pasotti

For the record: it was not fixed in 3.4 because the implementation is based on a feature which is only available in 3.6 hence a straight backport was

unfortunately not feasible.

#9 - 2019-02-25 04:53 PM - Steve Lowman

Is there any way to fix it in 3.4? It messes up our work flow quite badly.

#10 - 2019-02-25 04:58 PM - Alessandro Pasotti

There are multiple ways, see this article (not written by me) http://nyalldawson.net/2016/08/how-to-effectively-get-things-changed-in-qgis/

#11 - 2019-02-25 05:13 PM - Steve Lowman

Okay, thanks, | hope | am not being put into category 7. | just work here and have very little influence over anything, but | will make a suggestion.

Meanwhile, | guess you had better close this report again.

#12 - 2019-02-25 05:23 PM - Alessandro Pasotti

Thanks for your understanding: we have very limited time resources (not to mention the ridiculously slow budget) and we have to prioritize.

#13 - 2019-02-25 06:13 PM - Steve Lowman

Would you be able to recommend who best to contact to get a price estimate for fixing this in the LTR, or should | just contact someone local on the list at
https://www.qgis.org/en/site/forusers/commercial _support.html ?

#14 - 2019-02-25 06:25 PM - Alessandro Pasotti

In that list you can find a lot of qualified free-lance developers and companies (included myself), feel free to contact anyone.

#15 - 2019-02-25 08:57 PM - Giovanni Manghi
http://nyalldawson.net/2016/08/how-to-effectively-get-things-changed-in-qgis/
https://www.qgis.org/en/site/forusers/commercial_support.html

- Resolution set to fixed/implemented

- Status changed from Reopened to Closed

#16 - 2019-03-29 01:03 PM - Saber Razmjooei
- Assignee changed from Alessandro Pasotti to Martin Dobias
- Status changed from Closed to Open

#17 - 2019-04-09 09:41 AM - Martin Dobias
- Status changed from Open to Closed

Applied in changeset commit:qgis|9eca4059b8d09aab9eac5995f899a9bd07cd0083.
